#include <InputServerFilter.h>
#include <Point.h>
#include <Rect.h>
#include <Locker.h>

#include "Preferences.h"

class EasyMoveFilter : public BInputServerFilter
{
	public:
		EasyMoveFilter();
		virtual ~EasyMoveFilter();
		virtual filter_result Filter(BMessage *message, BList *outList);
		virtual status_t InitCheck();
		
	private:
		BMessenger *FindWindow(BPoint pos);
		void PutWinToBack();
		void BringToFront();
		void MoveWin();
		void SetWinWorkspaces(int32 ws);
		
		static status_t UpdateThreadFunc(void *cookie);
		
		BMessenger *mWinMsgr;
		int32 mWinToken;
		BRect mWinFrame;
		bool mValidFrame;
		uint32 mWinLook;
		bool mValidLook;
		int32 mWinWorkspaceMask;
		int32 mOldWorkspace;
		uint32 mWinFlags;
		bool mIsFrontMost;
		bool mIsBackMost;
		
		bool mIsMoving;
		
		BPoint mMousePos;
		
		float mRateCounter;
		float mRateCeil;
		
		int32 buttons;
		int32 modifiers;
		
		BPoint oldPos;
		int32 oldWorkspace;
		
		status_t init;
		
		Preferences prefs;
		thread_id updateThread;
		
		enum {LEFT=1, TOP=2, RIGHT=4, BOTTOM=8};
		int32 mResizingDirection;
};
