#include <Box.h>
#include <Invoker.h>

class ModifierView;

class ModifierBox : public BInvoker, public BBox
{
	public:
		ModifierBox(BRect frame, const char *label=0, uint32 modifier=0, uint32 button=0);
		~ModifierBox();
		
		virtual void MessageReceived(BMessage *message);
		virtual void AttachedToWindow();
		
		uint32 GetModifierMask();
		uint32 GetButtonMask();
		void SetModifierMask(uint32 mask);
		void SetButtonMask(uint32 mask);
		void SetDefaultModifierMask(uint32 mask);
		void SetDefaultButtonMask(uint32 mask);
		
	private:
		struct MaskListType
		{
			uint32 mask;
			char *label;
		};
		
		static const MaskListType ModifierList[];
		static const int32 NbModifiers;
		
		static const MaskListType ButtonList[];
		static const int32 NbButtons;
		
		ModifierView **mModifierViewList;
		ModifierView **mButtonViewList;
		
		uint32 mDefaultModifier;
		uint32 mDefaultButton;
		
		static const uint32 MODIFIER_CHANGED='modc';
		static const uint32 BUTTON_CHANGED  ='btnc';
};
