#include <SupportDefs.h>
#include <interface/View.h>

class BFile;

class Preferences
{
	public:
		Preferences();
		~Preferences();
		void Update();
		void Save();
		
		uint32 GetMoveModifierMask(){return mMoveModifierMask;}
		void SetMoveModifierMask(uint32 mask){mMoveModifierMask=mask;}
		uint32 GetDefaultMoveModifierMask(){return B_COMMAND_KEY;}
		
		uint32 GetMoveButtonMask(){return mMoveButtonMask;}
		void SetMoveButtonMask(uint32 mask){mMoveButtonMask=mask;}
		uint32 GetDefaultMoveButtonMask(){return B_PRIMARY_MOUSE_BUTTON;}
		
		
		uint32 GetResizeModifierMask(){return mResizeModifierMask;}
		void SetResizeModifierMask(uint32 mask){mResizeModifierMask=mask;}
		uint32 GetDefaultResizeModifierMask(){return B_COMMAND_KEY | B_OPTION_KEY;}
		
		uint32 GetResizeButtonMask(){return mResizeButtonMask;}
		void SetResizeButtonMask(uint32 mask){mResizeButtonMask=mask;}
		uint32 GetDefaultResizeButtonMask(){return B_PRIMARY_MOUSE_BUTTON;}
		
		
		uint32 GetFrontModifierMask(){return mFrontModifierMask;}
		void SetFrontModifierMask(uint32 mask){mFrontModifierMask=mask;}
		uint32 GetDefaultFrontModifierMask(){return B_COMMAND_KEY;}
		
		uint32 GetFrontButtonMask(){return mFrontButtonMask;}
		void SetFrontButtonMask(uint32 mask){mFrontButtonMask=mask;}
		uint32 GetDefaultFrontButtonMask(){return B_TERTIARY_MOUSE_BUTTON;}
		
		
		uint32 GetBackModifierMask(){return mBackModifierMask;}
		void SetBackModifierMask(uint32 mask){mBackModifierMask=mask;}
		uint32 GetDefaultBackModifierMask(){return B_COMMAND_KEY;}
		
		uint32 GetBackButtonMask(){return mBackButtonMask;}
		void SetBackButtonMask(uint32 mask){mBackButtonMask=mask;}
		uint32 GetDefaultBackButtonMask(){return B_SECONDARY_MOUSE_BUTTON;}
		
		
		bool GetToggleFront(){return mToggleFront;}
		void SetToggleFront(bool toggle){mToggleFront=toggle;}
		void SetToggleFrontToDefault(){mToggleFront=false;}
		
		bool GetToggleBack(){return mToggleBack;}
		void SetToggleBack(bool toggle){mToggleBack=toggle;}
		void SetToggleBackToDefault(){mToggleBack=false;}
		
		bool GetAnyWin(){return mAnyWin;}
		void SetAnyWin(bool any){mAnyWin=any;}
		void SetAnyWinToDefault(){mAnyWin=false;}
		
		float GetUpdateRate(){return mRate;}
		void SetUpdateRate(float rate){mRate=rate;}
		void SetUpdateRateToDefault(){mRate=1.0;}
		
		void SetToDefault();
		
	protected:
		BFile *OpenFile(uint32 openMode);
		void Load();
		
	private:
		static char const * const PrefsFilename="EasyMove";
		
		uint32 mMoveModifierMask;
		uint32 mMoveButtonMask;
		uint32 mResizeModifierMask;
		uint32 mResizeButtonMask;
		uint32 mFrontModifierMask;
		uint32 mFrontButtonMask;
		uint32 mBackModifierMask;
		uint32 mBackButtonMask;
		bool mToggleFront;
		bool mToggleBack;
		bool mAnyWin;
		float mRate;
};
