#include <Window.h>

#include "Preferences.h"

class BView;
class ModifierView;
class ModifierBox;

class SettingsWin : public BWindow
{
	public:
		SettingsWin();
		~SettingsWin();
		virtual void MessageReceived(BMessage *message);
		virtual bool QuitRequested();
		
	private:
		void SendUpdateMessage();
		
		BView *bg;
		
		struct MaskListType
		{
			uint32 mask;
			char *label;
		};
		
		static const MaskListType ModifierList[];
		static const int32 NbModifiers;
		
		static const MaskListType ButtonList[];
		static const int32 NbButtons;
		
		ModifierBox *mMoveBox;
		ModifierBox *mResizeBox;
		ModifierBox *mFrontBox;
		ModifierBox *mBackBox;
		
		BCheckBox *mToggleFront;
		BCheckBox *mToggleBack;
		BCheckBox *mAnyWindow;
		BTextControl *mRateText;
		
		Preferences mPrefs;
		
		static uint32 const MOVE_CHANGED  ='move';
		static uint32 const RESIZE_CHANGED='resz';
		static uint32 const FRONT_CHANGED ='frnt';
		static uint32 const BACK_CHANGED  ='back';
		
		static const uint32 TOGGLE_FRONT          ='tfrt';
		static const uint32 TOGGLE_BACK           ='tbak';
		static const uint32 ANY_WINDOW            ='anyw';
		static const uint32 PERCENT_CHANGE        ='pcnt';
};
